#include "basic_functions.h"


vector<pair<uint32_t, uint32_t>> getIndexPeriod(const uint32_t size,
                                                const uint8_t threadCnt)
{
    vector<pair<uint32_t, uint32_t>> ret;
    uint32_t whole_frame_cnt = size;
    uint32_t min_frame_cnt = whole_frame_cnt / threadCnt;
    uint32_t max_frame_cnt = min_frame_cnt + 1;
    uint8_t max_divide_cnt = whole_frame_cnt % threadCnt;
    uint32_t start_index = 0, last_item_cnt = 0;
    for(uint8_t thread_index = 0; thread_index < threadCnt; thread_index++){
        uint32_t item_cnt;
        if(thread_index < max_divide_cnt){
            item_cnt = max_frame_cnt;
        }else{
            item_cnt = min_frame_cnt;
        }
        start_index += last_item_cnt;
        ret.push_back(make_pair(start_index, item_cnt));
        last_item_cnt = item_cnt;
    }
    return ret;
}
